/*
    extendable array library
            12/Oct/2004   by Takeaki Uno  e-mail:uno@nii.jp, 
    homepage:   http://research.nii.ac.jp/~uno/index.html  */
/* This program is available for only academic use, basically.
   Anyone can modify this program, but he/she has to write down 
    the change of the modification on the top of the source code.
   Neither contact nor appointment to Takeaki Uno is needed.
   If one wants to re-distribute this code, do not forget to 
    refer the newest code, and show the link to homepage of 
    Takeaki Uno, to notify the news about the codes for the users.
   For the commercial use, please make a contact to Takeaki Uno. */

#ifndef _ary_h_
#define _ary_h_

#include"stdlib2.h"

typedef struct {
  void *h;   /* array */
  int unit;  /* the size of each cell*/
  int num;   /* maximum of the currently used cell */
  int end;   /* the size of cullently allocated array */
  int dellist;  /* memory pointers bty -(index)-2. -1 is mark of termination  */
} ARY;
#define ARY_CELL(a,b,c) ((a *)((b).h+((b).unit*c)))
#define ARY_INT(a,b)  (((int *)((a).h))[b])


/* print routine */
void ARY_print ( ARY *A );

  /* initialization, termination */
void ARY_init ( ARY *A, int unit );
void ARY_end ( ARY *A );

  /* expand the array to num. num is accessible. */
void ARY_exp ( ARY *A, int num );
  /* increment num */
void ARY_inc ( ARY *A );
  /* expand the array, and fill the new part by c */
void ARY_exp_const ( ARY *A, int num, int c );

  /* set num-th unitu to integer c */
void ARY_set ( ARY *A, int num, int c );
  /* increment num, and set num-th unit to c */
void ARY_set_inc ( ARY *A, int c );
  /* set num-th unit to c. if it is expanded, set the elements in the gap to c2 */
void ARY_set_const ( ARY *A, int num, int c, int c2 );
  /* set num-th element to *p */
void ARY_set_ ( ARY *A, int num, void *p );
  /* set A->num-th element to *p, and increment num */
void ARY_set_inc_ ( ARY *A, void *p );
  /* set num-th unit to *p. if expanded, set units in the gap to *p2 */
void ARY_set_const_ ( ARY *A, int num, void *p, void *p2 );

  /* delete one cell and insert the deletion list */
void ARY_del ( ARY *A, int num );
  /* delete one cell and move the last element here */
void ARY_rm ( ARY *A, int num );

  /* return a new cell, take from the deleted list, or increment num if empty */
int ARY_new ( ARY *A );

#endif

